unit UnitData;

interface

uses
   UnitFunc ;

type
   TZumenTitle = record       // }ʏb}ʕ\藓
      P_Name : string;        // Ɩ
      C_Name : string;        // H
      C_type : string;        // _敪
      D_title : string;       // }ʖ
      D_number : string;      // }ʔԍ
                              // }ʔԍ + $$ + }ʐō\B$$ȍ~̓IvV
      D_type : string;        // }ʎ
      D_Scale : string;       // ړx
      D_Year : integer;       // }ʍ쐬Nij
      D_Month : integer;      // V     112
      D_Day : integer;        // V     131
      C_Contractor : string;  // 󒍉Ж
      C_Owner : string;       // ƎҖ
   end;

   TZumenPaper = record       // }ʍ\bp
      name : string;          // }ʖ
      typ : integer;          // pTCY(0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
      orient : integer;       // c^敪(0:c,1:)
      x : integer;            // Rp(Pmm)
      y : integer;            // Rpc(Pmm)
   end;

   TDataClass = class
   public
      { Public 錾 }
      zt : TZumenTitle;    // }ʏb}ʕ\藓
      zp : TZumenPaper;    // }ʍ\bp
      constructor Create;
      destructor Free;
      procedure DataInit;
      function  StrCheck(s:string) : Boolean ;
      procedure PaperSet(t,o,x,y:integer) ;
   private
      { Private 錾 }
   end;

implementation

// 
constructor TDataClass.Create;
begin
   DataInit ;
end;

// 
destructor TDataClass.Free;
begin
   //
end;

// lZbg
procedure TDataClass.DataInit;
begin
   // 񒷂0偁(NULL)͋Ȃ̂Ŕp󔒂܂
   with zt do begin
      P_Name   := ' ';
      C_Name   := ' ';
      C_type   := ' ';
      D_title  := ' ';
      D_number := ' ';
      D_type   := ' ';
      D_Scale  := '1/1';
      D_Year   := 2011;
      D_Month  := 1;
      D_Day    := 1;
      C_Contractor := ' ';
      C_Owner  := ' ';
   end;
   with zp do begin
      name  := ' ';
      typ   := 0;
      orient:= 1;
      x     := 1189;
      y     := 841;
   end;
end;

// `FbN
//    (ret) OK : True  NG : False
//     0񒷁256 ǂ`FbN
function TDataClass.StrCheck(s:string) : Boolean ;
var
   t : AnsiString ;
   l : integer ;
begin
   t := AnsiString(s) ;
   l := Length(t) ;
   if (l > 0) and (l <= 256) then
      Result := True
   else
      Result := False ;
end;

// pTCYZbg
//    t : (0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
//          {(10:A0~2 11:A0~3 12:A1~3 13:A1~4 14:A2~3 15:A2~4 16:A2~5
//             17:A3~3 18:A3~4 19:A3~5 20:A3~6 21:A3~7 22:A4~3 23:A4~4
//             24:A4~5 25:A4~6 26:A4~7 27:A4~8 28:A4~9)
//          {(30:B0 31:B1 32:B2 33:B3 34:B4 35:B5 36:B6)
//    o : c^敪(0:c,1:)
//    x : Rp(Pmm) t=9̎Ɏw
//    y : Rpc(Pmm) t=9̎Ɏw
procedure TDataClass.PaperSet(t,o,x,y:integer) ;
begin
   case(t)of
   0: begin
         x := 1189;
         y :=  841;
      end;
   1: begin
         x := 841;
         y := 594;
      end;
   2: begin
         x := 594;
         y := 420;
      end;
   3: begin
         x := 420;
         y := 297;
      end;
   4: begin
         x := 297;
         y := 210;
      end;
   10:begin // A0~2
         x := 1682;
         y := 1189;
      end;
   11:begin // A0~3
         x := 2523;
         y := 1189;
      end;
   12:begin // A1~3
         x := 1783;
         y :=  841;
      end;
   13:begin // A1~4
         x := 2378;
         y :=  841;
      end;
   14:begin // A2~3
         x := 1261;
         y :=  594;
      end;
   15:begin // A2~4
         x := 1682;
         y :=  594;
      end;
   16:begin // A2~5
         x := 2102;
         y :=  594;
      end;
   17:begin // A3~3
         x :=  891;
         y :=  420;
      end;
   18:begin // A3~4
         x := 1189;
         y :=  420;
      end;
   19:begin // A3~5
         x := 1486;
         y :=  420;
      end;
   20:begin // A3~6
         x := 1783;
         y :=  420;
      end;
   21:begin // A3~7
         x := 2080;
         y :=  420;
      end;
   22:begin // A4~3
         x :=  630;
         y :=  297;
      end;
   23:begin // A4~4
         x :=  841;
         y :=  297;
      end;
   24:begin // A4~5
         x := 1051;
         y :=  297;
      end;
   25:begin // A4~6
         x := 1261;
         y :=  297;
      end;
   26:begin // A4~7
         x := 1471;
         y :=  297;
      end;
   27:begin // A4~8
         x := 1682;
         y :=  297;
      end;
   28:begin // A4~9
         x := 1892;
         y :=  297;
      end;
   30:begin // B0
			x := 1456;
			y := 1028;
      end;
   31:begin // B1
			x := 1028;
			y :=  728;
      end;
   32:begin // B2
			x := 728;
			y := 514;
      end;
   33:begin // B3
			x := 514;
			y := 364;
      end;
   34:begin // B4
         x := 364;
			y := 257;
      end;
   35:begin // B5
         x := 257;
			y := 182;
      end;
   36:begin // B6
			x := 182;
			y := 128;
      end;
   end;
   if (t >= 0)and(t <= 4) then begin
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;  // CM[lłꍇɔ
   end
   else if (t >= 10)and(t <= 28)
         or(t >= 30)and(t <= 36) then begin
      t := 9 ;
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;
   end
   else begin
      t := 9 ;
      if (x < 100) then x := 100 ;   // RTCY̏ꍇ̒l`FbN
      if (y < 100) then y := 100 ;   //    100mm`10000mmƂĂ
      if (x > 10000) then x := 10000 ;
      if (y > 10000) then y := 10000 ;
      // p̌
      if (x >= y) then
         o := 1
      else
         o := 0 ;
   end;

   zp.typ      := t ;
   zp.orient   := o ;
   zp.x        := x ;
   zp.y        := y ;
end;

end.
